package org.acme.log;

import org.jboss.logmanager.ExtFormatter;
import org.jboss.logmanager.ExtHandler;
import org.jboss.logmanager.ExtLogRecord;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class LogHandler extends ExtHandler {

    private final List<ExtLogRecord> records = new ArrayList<>();

    public LogHandler() {
        this.setFormatter(new ExtFormatter() {
            // we don't need any special treatment
            @Override
            public String format(ExtLogRecord extLogRecord) {
                return super.formatMessage(extLogRecord);
            }
        });
    }

    @Override
    protected void doPublish(ExtLogRecord extLogRecord) {
        records.add(extLogRecord);
    }

    public List<String> getLoggedMessagesFormatted() {
        return records.stream()
                .map(rec -> this.getFormatter().formatMessage(rec))
                .collect(Collectors.toList());
    }
}
